// drvtst.cpp: implementation of the drvtst class.
//
//////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <winioctl.h>

#include "addaErrors.h"
#include "eepReport.h"
#include "a16chlib.h"


#include "drvtst.h"

BYTE	*lpBuffer0;
BYTE	*lpBuffer1;

BYTE	*BufStart;
BYTE	*AdcBufStart;
DWORD	BufferSize;

BYTE	*IoStart;


// local function types
int	main_init(int ac, char *av[]);
void main_run();
void main_end();
void SaveToFile();
void DumpRegister(int card_num,DWORD s,DWORD length);
void DumpMemory(DWORD *s,DWORD length);


void DumpRegister(int card_num,DWORD s,DWORD length)
{
	int lines;
	int i,j;
	DWORD	value;

	lines = length/4;

	for (j=0;j<lines;j++) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			ADDA_ReadReg(card_num,s,&value);
			printf(" %8lx",value);
			s+=4;
		}
		printf("\n");
	}
	if (length - lines*4) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			ADDA_ReadReg(card_num,s,&value);
			printf(" %8lx",value);
			s+=4;
		}
		printf("\n");
	}
}

void DumpMemory(DWORD *s,DWORD length)
{
	int lines;
	int i,j;
	DWORD	value;

	lines = length/4;

	for (j=0;j<lines;j++) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			printf(" %8lx",*s++);
		}
		printf("\n");
	}

	if (length - lines*4) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			printf(" %8lx",*s++);
		}
		printf("\n");
	}
}


void ClrMem()
{
	int i;
	WORD *s;
	s = (WORD *)BufStart;
	BufferSize = 0x100000;


	for (i=0;i<(BufferSize>>1);i++) {
		*s++ = (i<<4);
	}
}


void DmaStart(int card_num)
{
	DWORD pos;

	WORD *s;
	int i;
	int length = 0x8000;
	int sample_rate = 22050;

	DWORD data;

	data = ADDA_GetDigitalTrgStatus(card_num);
	ADDA_ClrDigitalTrg(card_num,data);
	ADDA_SetDigitalPara(card_num,0xf,0);

	ADDA_ClrPosStatus(card_num,ADDA_GetPosStatus(card_num));
	ADDA_SetPosIrqEnable(card_num,(1<<15));

	printf("Digital Trg Status = %8lx\n",data);

	for (i=0;i<16;i++) {
		ADDA_SetTrgSrc(card_num,i,1<<29);	// always 
	}

//	for (i=8;i<16;i++) {
//		ADDA_SetTrgSrc(card_num,i,(1<<31) | (1<<16));	// digital input channel 0 event , pre-trigger event
//	}


	for (i=0;i<16;i++) {
		ADDA_DmaDacStart(card_num,i,length,sample_rate);
		ADDA_DmaAdcStart(card_num,i,length,sample_rate);
	}


	printf("press any key to quit the position event loop \n");

	BYTE *d0 = lpBuffer0;
	BYTE *d1 = lpBuffer1;
	DWORD size = 0;


	// fill the DAC buffer

	s = (WORD *)BufStart;
	*s = 0;
	for (i=0;i<length/2;i++) {

		//if (i&1) {
		//	*s++ = 0xffff;
		//}
		//else {
		//	*s++ = 0;
		//}
		*s++ = i*4;
	}


	while (1) {
		ADDA_GetDmaAdcPosOvl(card_num,0,&pos);

		// copy adc data to the memory
		memcpy(d0,AdcBufStart+(pos-1)*length/2,length/2);
		d0 += length/2;
		size += length/2;
		if (size>=BufferSize) break;
		printf("Pos = %d\n",pos);
		if (kbhit()) break;
	}
	if (kbhit()) getch();

	//printf("\nwait for the position event for the channel 16 \n");
	//ADDA_GetPositionOvl(ch,15, &pos);
	//printf("End of position trigger = %8lx\n",pos);
}



void DmaStop(int card_num)
{
	for (int i=0;i<16;i++) {
		ADDA_DmaDacStop(card_num,i);
		ADDA_DmaAdcStop(card_num,i);
	}
}


void DacTest(int card_num)
{
	WORD data[16];
	DWORD status,status1;
	int i;


	do {
		for (int j=0;j<0x10000;j+=0x100) {
			i=2;
			//for (i=0;i<16;i++) {
				ADDA_PutDac(card_num,i,j);
			//}

			// adc request
			ADDA_ReqAdc(card_num,0x4);
			//while (!ADDA_IsAdcEnded(card_num,0));

			Sleep(1);

			for (i=2;i<3;i++) {
				ADDA_ReadAdc(card_num,i,&(data[i]));
			}

			printf("%2d,%8lx, %8lx\n",i,j,data[2]);

			if (kbhit()) break;
		}
		if (kbhit()) break;
	}
	while (1);
	getch();
	printf("End Dac\n");
	

}


void giotst()
{

	DWORD data;
	DWORD status;

	// output & input  test

	if (0) {
		while (0) {
			ADDA_OutWrite(0,0xffffffff);
			Sleep(1);
			ADDA_InRead(0,&data);
			printf("read data = %8lx\r",data);
			ADDA_OutWrite(0,0);
			Sleep(1);
			ADDA_InRead(0,&data);
			printf("read data = %8lx\r",data);
			if (kbhit()) break;
		}
		getch();
	}

	// input interrupt test

	if (1) {

		while (1) {
			ADDA_InIrqSet(0,0,0xffffffff);
			ADDA_InReadOvl(0,&data,&status);
			printf("ReadInterrupt data = %8lx, status = %8lx\n",data,status);
			if (kbhit()) break;
		}
		getch();
	}
}


void SaveToFile()
{
	FILE *fp;
	int i;
	fp = fopen("data0.raw","wb");
	fwrite((void *)lpBuffer0,4, BufferSize>>2,fp);		// 8bit
	fclose(fp);

	fp = fopen("data1.raw","wb");
	fwrite((void *)lpBuffer1,4, BufferSize>>2,fp);		// 8bit
	fclose(fp);
}


int	main_init(int ac, char *av[])
{
	DWORD	dwErrorCode;
	int	ret = 0;


	if (ADDA_Init()) {

		BufferSize = 0x100000;
		lpBuffer0 = (BYTE *)malloc(BufferSize);
		lpBuffer1 = (BYTE *)malloc(BufferSize);

		// allocate the user buffer

		printf("Main Init,  card numbers = %d, ID = %d\n",ADDA_GetMaxCards(),ADDA_GetID(0));
		ADDA_GetDacBuf(0,1,&BufStart);
		ADDA_GetAdcBuf(0,1,&AdcBufStart);
		IoStart = ADDA_GetIoStart(0);

	}
	return ret;
}



void main_end()
{
	ADDA_End();
	free(lpBuffer0);
	free(lpBuffer1);
}


void main_run()
{
	char cmd;
	DWORD data = 0xaaaa5555;
	DWORD data1,data2;


	printf("\n\nsa)ve to file, q)uit :");
	do {

		if (_kbhit()) {

			cmd = _getch();

			printf("\n");

			switch (cmd) {

				case '1' : // dac data output test
					printf("Host DaC test \n");
					DacTest(0);
					break;


				case '2' : // DMA test
					printf("DMA transfer test\n");
					DmaStart(0);
					break;

				case '3' : // DMA stop
					printf("DMA stop\n");
					DmaStop(0);
					break;

				case '4' :// gpio test
					giotst();
					break;

				case '5' : 
					ADDA_GetPosition(0,15,&data);
					data1 = ADDA_GetPosStatus(0);
					ADDA_ReadReg(0,0xc04,&data2);
					printf("Position = %8lx,status = %8lx, irqen=%8lx\n",data,data1,data2);
					DumpRegister(0,0xc40,16);
					break;

				case 'a' : // save buffer to file
					printf("Save buffer contents to file\n");
					SaveToFile();
					break;

				case 'c' : // image capture reload
					printf("Image Capture Start reload mode \n");
					break;

				case 'v' : // view the registers
					printf("View the I/O rigisters, card numbers = %d\n",ADDA_GetMaxCards());
					DumpRegister(0,0,8);
					{
						int i;
						for (i=0; i<1;i++) {
							DumpRegister(i,0x400,0x40);
						}
					}
					break;


				case 'f' : // flush memory

					printf("flush image buffer\n");
					ClrMem();
					break;

				case 'd' : // dump heap memory
					printf("Dump heap memory\n");
					printf("Start = %8lx\n",BufStart);
					DumpMemory((DWORD *)BufStart,64);
					DumpMemory((DWORD *)(BufStart+0x10000*16),64);
					break;

					break;


				case 'q' :	// QUIT
					break;

				default :
					printf("Not supported command \n");
			}
			printf("\n\nsa)ve to file, dma_c)apture, dma_st)op, g)et_Info, q)uit :");
		}

	} while (cmd!='q');
}

void main(int ac, char *av[])
{
	if (!main_init(ac, av) ) {
		main_run();
		main_end();
	}
}
